var common = {};
//封装方法
/**
 * 定时器-标记定义
 */
common.TimerInfo=[],
/**
 * 定时器-标记赋值
 * @param {*} id 
 */
common.TimeSign=function (id){
    common.TimerInfo[id] = Date.parse(new Date())/1000;
},

/**
 * 定时器-主程序
 * @param {*} id 
 * @param {*} diff 
 */
common.Timer= function(id,diff){
    let t1 =Date.parse(new Date())/1000;
    
    if(t1-common.TimerInfo[id] >= diff){
        return true;
    }else{
        return false;
    }
},
//仿真随机带曲线滑动  
//qx, qy, zx, zy, time 代表起点x,起点y,终点x,终点y,过程耗时单位毫秒
common.swipeEx=function(qx, qy, zx, zy, time) {
    var xxy = [time];
    var point = [];
    var dx0 = {
        "x": qx,
        "y": qy
    };
    var dx1 = {
        "x": random(qx - 100, qx + 100),
        "y": random(qy, qy + 50)
    };
    var dx2 = {
        "x": random(zx - 100, zx + 100),
        "y": random(zy, zy + 50),
    };
    var dx3 = {
        "x": zx,
        "y": zy
    };
    for (var i = 0; i < 4; i++) {

        eval("point.push(dx" + i + ")");

    };
    for (let i = 0; i < 1; i += 0.08) {
        xxyy = [parseInt(this.bezier_curves(point, i).x), parseInt(this.bezier_curves(point, i).y)]
        xxy.push(xxyy);
    }
    gesture.apply(null, xxy);
},
common.bezier_curves=function(cp, t) {
    cx = 3.0 * (cp[1].x - cp[0].x);
    bx = 3.0 * (cp[2].x - cp[1].x) - cx;
    ax = cp[3].x - cp[0].x - cx - bx;
    cy = 3.0 * (cp[1].y - cp[0].y);
    by = 3.0 * (cp[2].y - cp[1].y) - cy;
    ay = cp[3].y - cp[0].y - cy - by;

    tSquared = t * t;
    tCubed = tSquared * t;
    result = {
        "x": 0,
        "y": 0
    };
    result.x = (ax * tCubed) + (bx * tSquared) + (cx * t) + cp[0].x;
    result.y = (ay * tCubed) + (by * tSquared) + (cy * t) + cp[0].y;
    return result;
},
//向左滑动
common.slideToLeft=function(){
    common.swipeEx(device.width * 0.9, device.height * 0.5, device.width * 0.1,device.height * 0.5, 300);
},
//短滑动
common.shortSlide=function() {
    common.swipeEx(device.width * 0.5, device.height * 0.5, device.width * 0.5, device.height * 0.5 - 500, 300);
},
//底部短滑动
common.bshortSlide=function() {
    common.swipeEx(device.width * 0.5, device.height * 0.8, device.width * 0.5, device.height * 0.8 - 500, 300);
},
//滑动通用方法
common.slide=function() {
    common.swipeEx(device.width * 0.8, device.height * 0.6, device.width * 0.9, 0, 300)
},
/***区域点击 */
common.rgClick=function(region){
    if(click(random(region[0], region[0] + region[2]), random(region[1], region[1] + region[3]))){
        return true;
    }else{
        return false;
    }
},
/**
 * 随机取指定长度的字符
 * @param {*} len 
 */
common.randomString=function(len) {
　　len = len || 32;
　　var $chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';    /****默认去掉了容易混淆的字符oOLl,9gq,Vv,Uu,I1****/
　　var maxPos = $chars.length;
　　var pwd = '';
　　for (i = 0; i < len; i++) {
　　　　pwd += $chars.charAt(Math.floor(Math.random() * maxPos));
　　}
　　return pwd;
},
common.randomNum=function(minNum,maxNum){
    minNum = minNum/1000;
    maxNum = maxNum/1000;
    switch(arguments.length){ 
    case 1:
        return parseInt(Math.random()*minNum+1)*1000; 
        break;
    case 2: 
        return parseInt(Math.random()*(maxNum-minNum+1)+minNum)*1000; 
        break; 
    default: 
        return 0; 
        break; 
    } 
},
/**
 * 点击第i个子节点num次
 * @param {*} node 
 * @param {*} i 
 * @param {*} num 
 */
common.clickChildNum=function(node,i,num){
    if(node){
        let child = [node.child(i).bounds().centerX(),node.child(i).bounds().centerY(),100,100];
        
        for (let index = 0; index <= parseInt(num); index++) {
            click(child[0],child[1]);
            sleep(random(2000,3200));
        }
    }
}
module.exports = common;